APIBase = require('../src')
getopt = require('posix-getopt')
parser = new getopt.BasicParser('to:(operation)p:(parameter)', process.argv)

OP_GET_GIST = '99d64f8e-eace-417d-8cea-511621aaf57c'
GIST_ID = '6a06816491046e57e658'
GIST_RESOURCE = '5cb3434f-0351-461b-9fe0-89d11b2c046c'

parameters = {}
op = null
paramReg = /(\S+)=(\S+)/
while (option = parser.getopt())
  switch option.option
    when 'p'
      m = paramReg.exec option.optarg
      if not m
        console.error "parameter should follow the \"field=value\" syntax"
        process.exit 1
      parameters[m[1]] = m[2]
    when 'r'
      m = paramReg.exec option.optarg
      if not m
        console.error "parameter should follow the \"field=resource\" syntax"
        process.exit 1
      parameters[m[1]] = "resource://#{m[2]}"
    when 'o'
      op = option.optarg
    when 't'
      op = OP_GET_GIST
      parameters['gistId'] = "resource://#{GIST_RESOURCE}"
    else
      console.log 'unknown option:', option.option
      process.exit(1)


unless op
  console.error "operation missing"
  process.exit 1

client = new APIBase({
  baseUrl: 'http://johnsd.cse.unsw.edu.au:3000'
})

client.invokeOperation op, parameters, null, null, (err, resp)->
  if err
    console.log err
    return
  console.log resp.body
  # files = []
  # for name,f of resp.files
  #   files.push name
  # console.log "gist id: ", resp.id
  # console.log "url: ", resp.html_url
  # console.log "files:", files
